jQuery(function ($) {

    // Dropdown menu
    $(".wps-sidebar-dropdown > a").click(function (e) {
      e.preventDefault();
      $(".wps-sidebar-submenu").slideUp(200);
      if ($(this).parent().hasClass("active")) {
          $(".wps-sidebar-dropdown").removeClass("active");
          $(this).parent().removeClass("active");
      } else {
          $(".wps-sidebar-dropdown").removeClass("active");
          $(this).next(".wps-sidebar-submenu").slideDown(200);
          $(this).parent().addClass("active");
      }

    });

    //toggle sidebar
    $("#toggle-sidebar").click(function (e) {
      e.preventDefault();
      $("#wpcontent").toggleClass("toggled");
    });
    //Pin sidebar
    $("#pin-sidebar").click(function (e) {
      e.preventDefault();
      if ($("#wpcontent").hasClass("pinned")) {
          // unpin sidebar when hovered
          $("#wpcontent").removeClass("pinned");
          $("#wpfooter").removeClass("pinned");
          $("#wps-sidebar").unbind( "hover");
      } else {
          $("#wpcontent").addClass("pinned");
          $("#wpfooter").addClass("pinned");
          $("#wps-sidebar").hover(
              function () {
                  console.log("mouseenter");
                  $("#wpcontent").addClass("wps-sidebar-hovered");
                  $("#wpfooter").addClass("wps-sidebar-hovered");
              },
              function () {
                  console.log("mouseout");
                  $("#wpcontent").removeClass("wps-sidebar-hovered");
                  $("#wpfooter").addClass("wps-sidebar-hovered");
              }
          )

      }
    });

    //generate cookie for current menu item
    $('.wps-submenu-item > a').click(function (e) {
      var menuID = $(this).parent().parent().parent().parent().attr('id');
      Cookies.set('wps_current_menu', menuID, { expires: 1 });
    });
    $('.wps-menu-item > a').click(function (e) {
      var menuID = $(this).parent().attr('id');
      Cookies.set('wps_current_menu', menuID, { expires: 1 });
    });


    //toggle sidebar overlay
    $("#overlay").click(function () {
        $("#wpcontent").toggleClass("toggled");
    });

    // toggle background image
    $("#toggle-bg").change(function (e) {
        e.preventDefault();
        $('#wpcontent').toggleClass("sidebar-bg");
    });

    //custom scroll bar is only used on desktop
    if (!/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        $(".wps-sidebar-content").mCustomScrollbar({
            axis: "y",
            autoHideScrollbar: true,
            scrollInertia: 300
        });
        $(".wps-sidebar-content").addClass("desktop");

    }

    $('#wps_menu_blog').on('change', function(){

        var blog_id = $('#wps_menu_blog').val();

        $("#user_role_id").find('option').remove();
        
        var roles = $("#user_role_id");

        var menu_id = '';

        if($('#wps_edit_menu_id').length)
        {
          menu_id = $('#wps_edit_menu_id').val();
        }
              
        if(blog_id.length > 0){
          roles.append("<option value=''>Loading ... </option>");
           $.ajax({
                url: wpspb_sidebar_admin_ajax_url.admin_ajax_url,
                type: "POST",
                data: {
                    action: 'showrolesbyblog',
                    security: wpspb_sidebar_admin_ajax_url.nonce,
                    blog_id: blog_id,
                    menu_id: menu_id,
                },
                dataType: "json",
                success: function (response) {       
                    $("#user_role_id").find('option').remove();                 
                    $.each(response, function(key, role){
                        roles.append("<option value="+key+">" + role + "</option>");
                    });
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console.log(xhr)
                }
            });
        }
    });
});
